package binky.ofc2plugin.charts;

import java.util.LinkedList;
import java.util.List;

import org.json.simple.JSONObject;

import binky.ofc2plugin.charts.config.TextItem;
import binky.ofc2plugin.charts.config.XAxis;
import binky.ofc2plugin.charts.config.YAxis;
import binky.ofc2plugin.charts.elements.Element;

public class OFC2Chart  {

	private TextItem title;
	private TextItem yLegend;
	private XAxis xAxis;
	private YAxis yAxis;
	private List<Element> elements=new LinkedList<Element>();
	private String backGroundColour;
	
	public TextItem getTitle() {
		return title;
	}

	public void setTitle(TextItem title) {
		this.title = title;
	}

	public TextItem getYLegend() {
		return yLegend;
	}

	public void setYLegend(TextItem legend) {
		yLegend = legend;
	}

	public XAxis getXAxis() {
		return xAxis;
	}

	public void setXAxis(XAxis axis) {
		xAxis = axis;
	}

	public YAxis getYAxis() {
		return yAxis;
	}

	public void setYAxis(YAxis axis) {
		yAxis = axis;
	}

	public List<Element> getElements() {
		return elements;
	}

	public void addElement(Element e) {
		this.elements.add(e);
	}
	
	
	
	public String getBackGroundColour() {
		return backGroundColour;
	}

	public void setBackGroundColour(String backGroundColour) {
		this.backGroundColour = backGroundColour;
	}

	@SuppressWarnings("unchecked")
	public String encodeJSONString() {
	JSONObject chartJSON = new JSONObject();
		
		if (this.getTitle()!=null) {
			//add the title
			chartJSON.put("title", this.getTitle().encode());
		}
		
		if (this.getYLegend()!=null) {
			//add the yLegend
			chartJSON.put("y_legend", this.getYLegend().encode());		
		}
		
		//add the x-axis
		if (this.getXAxis()!=null) {
			chartJSON.put("x_axis", this.getXAxis().encode());
		}
		
		//add the y-axis
		if (this.getYAxis()!=null) {
			chartJSON.put("y_axis", this.getYAxis().encode());
		}

		//add the elements
		List<JSONObject> elementList = new LinkedList<JSONObject>();
		
		for (Element e:this.getElements()) {
			elementList.add(e.encode());
		}
		
		if (backGroundColour!=null) {
			chartJSON.put("bg_colour", backGroundColour);
		}
		
		chartJSON.put("elements",elementList);
		
		//render the JSON
		return chartJSON.toJSONString();
	}
}