package binky.ofc2plugin.charts.config;

import org.json.simple.JSONObject;

import binky.ofc2plugin.charts.json.JSONEncodable;


public class TextItem implements JSONEncodable {
	private String text;
	private int fontSizePx=10;
	private String fontColourHex="#000000";
	private FontFamily fontFamily=FontFamily.Arial;
	private TextAlign textAlign=TextAlign.Left;

	public TextItem() {}
	public TextItem(String text) {
		this.text=text;
	}

	@SuppressWarnings("unchecked")
	public JSONObject encode() {
		
		//create a JSON element that encodes a text item
		JSONObject item = new JSONObject();
		String style="{";
		
		//encode the text
		item.put("text", this.text);
		
		//encode style
		style +="font-size:"+fontSizePx;
		style +=";color:"+fontColourHex;
		style +=";font-family:"+fontFamily.getDisplayName();
		style +=";text-align:"+textAlign.getDisplayName();
		
		item.put("style",style);
		return item;
	}
	

	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}

	public int getFontSizePx() {
		return fontSizePx;
	}

	public void setFontSizePx(int fontSizePx) {
		this.fontSizePx = fontSizePx;
	}

	public String getFontColourHex() {
		return fontColourHex;
	}

	public void setFontColourHex(String fontColourHex) {
		this.fontColourHex = fontColourHex;
	}

	public FontFamily getFontFamily() {
		return fontFamily;
	}

	public void setFontFamily(FontFamily fontFamily) {
		this.fontFamily = fontFamily;
	}

	public TextAlign getTextAlign() {
		return textAlign;
	}

	public void setTextAlign(TextAlign textAlign) {
		this.textAlign = textAlign;
	}
	public enum FontFamily {

		Verdana("Verdana"), Arial("Arial");
		private String displayName;

		FontFamily(String displayName) {
			this.displayName = displayName;
		}

		public String getName() {
			return name();
		}

		public String getDisplayName() {
			return displayName;
		}

	}
	
	public enum TextAlign {

		Left("Left"), Right("Left"), Centre("Center");
		private String displayName;

		TextAlign(String displayName) {
			this.displayName = displayName;
		}

		public String getName() {
			return name();
		}

		public String getDisplayName() {
			return displayName;
		}

	}
}
