package binky.ofc2plugin.charts.elements;

import org.json.simple.JSONObject;

import binky.ofc2plugin.charts.json.JSONEncodable;

public abstract class Element implements JSONEncodable {

	private Number alpha = 0.5;
	private String colourHex = "#FF0000";
	private String text;
	private Number fontSizePx = 10;

	protected String elementName;

	@SuppressWarnings("unchecked")
	public JSONObject encode() {
		JSONObject element = new JSONObject();
		element.put("type", this.elementName);
		element.put("alpha", this.alpha);
		element.put("colour", this.colourHex);
		if (text != null) {
			element.put("text", this.text);
		}
		element.put("font-size", this.fontSizePx);
		return element;
	}

	public Number getAlpha() {
		return alpha;
	}

	public void setAlpha(Number alpha) {
		this.alpha = alpha;
	}

	public String getColourHex() {
		return colourHex;
	}

	public void setColourHex(String colourHex) {
		this.colourHex = colourHex;
	}

	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}

	public Number getFontSizePx() {
		return fontSizePx;
	}

	public void setFontSizePx(Number fontSizePx) {
		this.fontSizePx = fontSizePx;
	}

	protected static final String PIE_NAME = "pie";
	protected static final String HBAR_NAME = "hbar";
	protected static final String LINE_DOT_NAME = "line_dot";
	protected static final String LINE_STANDARD_NAME = "line";
	protected static final String LINE_HOLLOW_NAME = "line_hollow";
	protected static final String STACKED_BAR_NAME = "stacked_bar";
	protected static final String RADAR_NAME = "radar";
	protected static final String SCATTER_NAME = "scatter";
	protected static final String AREA_NAME = "area";

}
